#!/usr/bin/perl 
#
# Sensor for gathering disk status data for Zabbix via
# smartmontools.
# Copyright (c) 2008 Jakov Sosic
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
# Changes and Modifications
# * Tue Mar 17 18:04:50 CET 2009
# 	- fixed alarms
# * Thu May 15 03:40:39 CEST 2008       
#       - script created
#

# zabbix path
my $zabbix_sender="/usr/bin/zabbix_sender";
my $zabbix_confd="/etc/zabbix/zabbix_agentd.conf";
my $smartmon="/usr/sbin/smartctl";
my $zabbix_send_command="$zabbix_sender -c $zabbix_confd";
#my $conf="/home/zabbix/bin/ccissvol_smartmon_sensor_conf";
#my $conf="/usr/lib/zabbix-agent/ccissvol_smartmon_sensor_conf";

# signal handling
$SIG{'ALRM'} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
	exit(-1);
};

local $SIG{TERM} = sub {
	local $SIG{TERM} = 'IGNORE';
	kill TERM => -$$;
	print "0\n";
	exit(-1);
};

$arg=shift; #print $arg;
my @disks=split(":",$arg);
# fetch status from mod_status

if($#disks+1<1){
  print "0\n" and exit(-1);
}
alarm 25;
#open FILE, $conf;
my $flag=1;
my $i=0;
foreach (@disks){
  my $optD="";
  if($_ =~ /\/dev\/cciss\/c0d/){
    $optD="-d cciss,0";   
  }#<FILE>;
  #chomp $disk;
 
  #if($disk =~ /cciss/) { $optD="-d cciss,0";}
  #if($disk =~ /sda/) {$optD="-d scsi";}

  my $cmd = "/usr/bin/sudo $smartmon -a -H $optD $_";

  my $server_status = qx($cmd);

#  if (!$server_status) { print "test\n"; exit();  }

  # get information from status output
  my $health="";
  my $currtemp="";
  my $hours="";
  $health = $1 if ($server_status =~ /Health Status:\s+(.+)/);
  $currtemp = $1 if ($server_status =~ /Current Drive Temperature:\s+([\d]+)/);
 # $hours = $1 if ($server_status =~ /hours powered up =\s+([\d|\.]+)/);

  # print $health."\n".$currtemp."\n".$hours;


  # send information to Zabbix server
  if($health eq "OK"){$health=1;}
  else {$health=0;}

  if ( qx($zabbix_send_command -k smartmon.health.disk$i -o $health) =~ /failed:\ 1/  or ($health eq "")  ) { if($flag){"0\n"; $flag=0;}} 
  if ( qx($zabbix_send_command -k smartmon.currentTemp.disk$i -o $currtemp) =~ /failed:\ 1/  or ($currtemp eq "")) { if($flag){print"0\n"; $flag=0;}}
 # if ( qx($zabbix_send_command -k smartmon.hours.disk$i -o $hours) =~ /failed:\ 1/ or !$hours ) {if($flag){print"s0\n"; $flag=0;}}
  $i++;
}

if(!$flag) {exit(-1);}
print "1\n";
exit(0);
# EOF
